#include <iostream>
#include <string>
#include "map.h"
#include "expr_interpr.h"


int main() {
    Variable* e1 = new Variable("x");
    Constant* e2 = new Constant(2);
    PlusExpr* e3 = new PlusExpr(e1, e2);

    Constant* e4 = new Constant(4);
    Variable* e5 = new Variable("y");
    PlusExpr* e6 = new PlusExpr(e4, e5);

    MultExpr* e7 = new MultExpr(e3, e6);

    std::cout<<e7->toString()<<'\n';

    Map<std::string, int> varToInt;
    varToInt.put("x", 1);
    varToInt.put("y", 0);
    std::cout<<e7->eval(varToInt)<<'\n';

    delete e7;
    return 0;
}
